laravel/routes/web.php
<?php

Route::redirect('/', 'login');

Route::view('email-test', 'email');

Auth::routes();

#Se redirecciona la ruta de registro a inicio de sesión
Route::redirect('register', 'login');

Route::view('under-construction', 'errors.under-construction')->name('under-construction');

Route::get('pdf-event', function(){

    $ticket = App\Ticket::first();

    return view('helpdesk.tickets.pdf.event', compact('ticket'));
});

#Rutas que requieren autenticación
Route::group(['middleware' => 'auth'], function () {


    Route::get('/home', 'DashboardController@index');


    Route::get('/', 'DashboardController@index')->name('home');
     

    #Notificaciones
    Route::get('notifications', 'NotificationsController@index')->name('notifications');
    Route::post('notification/{notification}/read', 'NotificationsController@read')->name('read-notification');
    Route::post('notification/archive', 'NotificationsController@destroy')->name('archive-notification');
    Route::get('notification/list-archive', 'NotificationsController@list_archive')->name('list-archive');


    #Busqueda avanzada
    Route::get('search', 'TicketController@advance_search')->name('advance-search');
    

    #Ticket
    Route::resource('tickets', 'TicketController');
    Route::post('tickets/archive', 'TicketController@archive_tickets')->name('archive-tickets');
    Route::get('ticket_list_archive', 'TicketController@list_archive')->name('list-archive-tickets');
    Route::get('tickets/{ticket}/show_deleted', 'TicketController@show_deleted')->name('show_deleted');
    Route::post('tickets/unarchive', 'TicketController@unarchive_tickets')->name('unarchive-tickets');
    Route::post('{ticket}/set-public-comment', 'TicketController@set_public_comment')->name('public-comment')->middleware('ticket_owner');
    // Route::post('{ticket}/set-internal-comment', 'TicketController@set_internal_comment')->name('internal-comment')->middleware('role:admin,agent,manager');
    Route::post('tickets/{ticket}/download', 'TicketController@to_pdf')->name('export_ticket_to_pdf');

    #Reabrir ticket
    Route::post('reopen_ticket/{ticket}', 'ReopenTicketController@reopen_ticket_action')->name('reopen_ticket')->middleware('role:company,agent');
    Route::get('read_reopen_ticket/{reopen_ticket}', 'ReopenTicketController@mark_reopen_ticket_as_read')->name('read_reopen_ticket');
    

    #Tareas
    Route::resource('tickets.tasks', 'TaskController')->only(['store', 'show', 'update', 'destroy']);
    Route::post('tickets/{ticket}/tasks/{tasks}/start_end_task', 'TaskController@start_end_task')->name('start-end-task');
    Route::get('tasks', 'TaskController@index')->name('agent-tasks')->middleware('role:agent');
    Route::post('tickets/{ticket}/tasks/{tasks}/reassing', 'TaskController@reassign')->name('reassing-task');
    Route::resource('tickets.tasks.events', 'TaskEventController');
    

    #Asignar proyecto
    Route::post('ticket/{ticket}/assign_to_project', 'ProjectTicketController@assign_ticket_to_project')->name('assign_to_project');

    #Departamentos
    Route::resource('departments', 'DepartmentController');
    Route::get('departments/{department}/agents', 'DepartmentController@get_department_agents')->name('get_department_agents');


    #Grupos de Departamentos
    Route::resource('departments.groups', 'DepartmentGroupController');
    

    #Agentes
    Route::resource('agents', 'AgentController');
    

    #Compañias
    Route::resource('companies', 'CompanyController');
    

    #Equipos
    Route::resource('companies.gears', 'GearController')->except(['create']);
    Route::resource('companies.gears.modules', 'GearModuleController');
    

    Route::post('insert/{module}/into/{gear}', 'GearModuleController@insert_module')->name('insert_module');
    Route::post('remove/{module}', 'GearModuleController@remove_module')->name('remove_module');


    Route::get('{type}/get-brands', 'GearController@get_brands')->name('get_brands');
    Route::get('{brand}/get-models', 'GearController@get_models')->name('get_models');
    Route::get('{company}/{model}/gears', 'GearController@get_gears_by_model')->name('get_gears_by_model');
    Route::post('reassing/{gear}', 'GearController@reassign_gear_to_zone')->name('reassign_gear_to_zone');
    Route::post('companies/{company}/gears/search', 'GearController@search_gear')->name('search_gear');
    Route::post('companies/{company}/gears/download', 'GearController@download_company_gear')->name('download_company_gear');


    #Zonas de compañias
    Route::resource('companies.zones', 'CompanyZonesController');
    
    
    #Tipos de contacto
    Route::resource('contact-types', 'CompanyUserTypeController');


    #Contactos de compañias
    Route::resource('companies.contacts', 'CompanyUserController');
    Route::get('{zone}/get_contacts', 'CompanyUserController@get_zone_contacts')->name('get_zone_contacts');


    #Catalogos de contacto
    Route::resource('companies.contact-catalogs', 'ContactCatalogController');


    #Zonas usuarios
    Route::resource('zoneusers', 'ZoneUserController');


    #Marcas de equipo
    Route::resource('brands', 'GearBrandController')->except(['create', 'edit']);
    

    #Agregar tipos de equipo a marcas
    Route::resource('brands.types', 'BrandTypeController');


    #Tipos de equipo
    Route::resource('types', 'GearTypeController')->except(['index', 'create', 'edit']);


    #Modelos de equipo
    Route::resource('brands.types.models', 'GearModelController')->except(['create', 'edit']);
    

    #Garantias
    Route::resource('warranties', 'WarrantyController');


    #Coberturas
    Route::resource('coverages', 'CoverageController');
    

    #Contratos
    Route::resource('contracts', 'ContractController');
    

    #Acuerdos se servicio (SLA)
    Route::resource('sla', 'SLAController');
    

    #Opciones ticket
    Route::resource('ticket-options', 'TicketOptionController');    


    #Estatus ticket
    Route::resource('status', 'StatusController');
    

    #Severidad ticket
    Route::resource('severity', 'SeverityController');
    

    #Categorias ticket
    Route::resource('category', 'CategoryController');
    Route::resource('category.subcategory', 'SubCategoryController');
    

    #Perfil 
    Route::resource('profile', 'ProfileController');
    

    #Directorio
    Route::resource('directory', 'DirectoryController');


    #Encuestas
    Route::resource('users', 'UserController');
    

    #Encuestas
    Route::resource('surveys', 'SurveyController');


    #Preguntas
    Route::resource('surveys.questions', 'QuestionController');


    #Reportes
    Route::get('reports', 'ReportController@index')->name('reports');
    Route::get('reports/{company}/contacts', 'ReportController@get_company_contacts')->name('get_company_contacts');
    Route::get('reports/{company}/contracts', 'ReportController@get_company_contracts')->name('get_company_contracts');
    Route::get('reports/{company}/company_gears', 'ReportController@get_company_gears')->name('get_company_gears');
    Route::get('reports/{company}/coverages', 'ReportController@get_company_coverages')->name('get_company_coverages');
    Route::post('reports/get_report', 'ReportController@get_report')->name('get_report');



    #Proyectos por compania
    Route::resource('companies.projects', 'CompanyProjectController');
    Route::post('companies/{company}/projects/{project}/project_ticket', 'ProjectController@project_ticket')->name('new-project-ticket');

    #Proyectos general
    Route::resource('projects', 'ProjectController');
    Route::get('project/details', 'ProjectController@project_details')->name('project_details');
    Route::post('project/{project}/cancel', 'ProjectController@cancel_project')->name('cancel_project');
    Route::post('project/{project}/active', 'ProjectController@active_project')->name('active_project');

    #Inventario
    Route::resource('inventories', 'InventoryController');
    Route::resource('inventories.stock', 'StockController');
    Route::post('inventories/{inventory}/stock/{stock}/assign_company_to_gear', 'StockController@assign_gear_to_company')->name('assign_gear_to_company');

    #Cotizaciones
    Route::resource('companies.projects.quotations', 'QuotationController');
    Route::post('companies/{company}/projects/{project}/validate_quotation', 'QuotationController@validate_quotation')->name('validate_quotation');
});

laravel/app/Department.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Department extends Model
{
    
	protected $table   = 'departments';
    public $timestamps = true;
    protected $guarded = [];

	public function tickets(){

		return $this->hasMany('App\Ticket', 'department_id', 'id');

	}

	public function agents(){

		return $this->hasMany('App\Agent', 'department_id', 'id');

	}

	public function supervisor(){

		return $this->hasOne('App\Agent', 'id', 'supervisor_id');

	}

	public function groups(){


		return $this->hasMany('App\DepartmentGroup', 'department_id', 'id');

	}

}

laravel/app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Database\Eloquent\SoftDeletes;

class User extends Authenticatable
{
    use Notifiable;

    use SoftDeletes;

    protected $dates = ['deleted_at'];

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'first_name', 'last_name', 'email', 'password', 'role', 'username',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    public function agent()
    {

        return $this->hasOne('App\Agent', 'user_id', 'id');

    }

    public function zones()
    {

        return $this->hasMany('App\ZoneUser', 'user_id', 'id');

    }

    public function contact()
    {

        return $this->hasOne('App\CompanyUser', 'user_id', 'id');

    }

    public function getFullNameAttribute()
    {

        return "{$this->first_name} {$this->last_name}";

    }

    public function companies()
    {

        #coleccion de compañias
        $companies = collect([]);
        
        #se verifica que una compañia se agregue solo una vez
        $zones = collect([]);

        $this->zones->each(function($zone) use ($companies, $zones) {
            collect($zone->company->all_childs())->each(function($zone) use ($companies, $zones) {

                if(!in_array($zone->id, $zones->toArray())){
                    
                    $zones->push($zone->id);
                    $companies->push($zone);

                }

            });
        });

        return $companies;
    }

    public function getAgentIsSupervisorAttribute()
    {
        $result = false;

        if ( isset( $this->agent ) ) {
            
            if ( optional( $this->agent->department )->supervisor_id == $this->agent->id ) {
                
                $result = $this->agent->department;

            }

        }

        return $result;
    }

    public function getAgentAsManagerAttribute()
    {
        $result = false;

        if ( isset( $this->agent ) ) {
            if ( $this->agent->as_manager ) {
                $result = true;
            }
        }

        return $result;
    }

    public function getAgentsInGroupAttribute()
    {   
        $agents_in_groups = false;

        if ( isset( $this->agent ) ) {
            $groups = $this->agent->supervisor_in_groups;

            if($groups->count() > 0){

                $agents_in_groups = [];

                foreach($groups as $group){
                    
                    if ($agents = $group->agents()->count() > 0) {

                        $agents = $group->agents()->with('agent')->get()->pluck('agent.id');

                        foreach($agents as $agent){

                            if( ! in_array($agent, $agents_in_groups)){

                                array_push($agents_in_groups, $agent); 

                            }
                        }
                    }
                }
            }
        }

        return $agents_in_groups;
    }

    public function getZonesFromContactTypeAttribute()
    {
        $ids = false;
        if ( isset( $this->contact ) ) {

            foreach ($this->zones as $zone) {

                $ids[$zone->company->id] = $zone->company->id;
                #se obtendran las companias de las zonas
                if (optional($zone->company)->id) {
                    #se obtendran los hijos de la compania si son de contacto principal
                    if ($zone->role == 'Contacto Principal') {

                        $company_childs = $zone->company->all_childs();

                    } else {

                        $company_childs = $zone->company->childs;

                    }

                    if (count($company_childs) > 0) {

                        foreach ($company_childs as $company_child) {

                            $ids[$company_child->id] = $company_child->id;
                        }

                    }
                }
            }
        }

        return $ids;
    }

    public function tickets_contact()
    {
        return $this->hasMany('App\Ticket', 'contact_id', 'id');
    }
}

laravel/resources/views/helpdesk/departments/create.blade.php
@extends('layouts.master')
@section('content')
<div class="container">
	<div class="card">
		<div class="card-header card_header_fixed">
			<a class="btn btn-link p-0" href="{{ route('departments.index') }}/">
				<i class="fa fa-angle-left"></i>
				Regresar
			</a>
		</div>
		<div class="card-body">
			<form action="{{ route('departments.store') }}" method="post" id="newDepartmentForm">
				
				{{ csrf_field() }}

				@include('helpdesk.departments.partials.form')
				
			</form>
		</div>
		<div class="card-footer">
			<div class="row d-flex">
				<div class="col-sm-8 ml-auto">
					<button type="submit" form="newDepartmentForm" id="department_form_btn" class="btn btn-success">
						<i class="fa fa-check"></i>
						Guardar Departamento
					</button>
				</div>
			</div>
		</div>
	</div>
</div>
@stop

laravel/resources/views/helpdesk/departments/edit.blade.php
@extends('layouts.master')
@section('content')
<div class="container">
	<div class="card">
		<div class="card-header card_header_fixed">
			<a class="btn btn-link p-0" href="{{ route('departments.show', $department) }}/">
				<i class="fa fa-angle-left"></i>
				Regresar
			</a>
		</div>
		<div class="card-body">
			<form action="{{ route('departments.update', $department) }}" method="post" id="newDepartmentForm">
				
				{{ csrf_field() }}
				{{ method_field('PATCH') }}

				@include('helpdesk.departments.partials.form')
				
			</form>
		</div>
		<div class="card-footer">
			<div class="row d-flex">
				<div class="col-sm-8 ml-auto">
					<button type="submit" form="newDepartmentForm" id="department_form_btn" class="btn btn-success">
						<i class="fa fa-check"></i>
						Actualizar Departamento
					</button>
				</div>
			</div>
		</div>
	</div>
</div>
@stop

laravel/resources/views/helpdesk/departments/index.blade.php
@extends('layouts.master')

@section('content')
<div class="container">
    <div class="card">
        <div class="card-header d-flex align-items-center">
            <p class="lead">
                Listado de departamentos
            </p>
            <form action="{{ route('departments.index') }}" method="get" enctype="multipart/form-data" class="form-inline ml-auto">
                <input class="form-control mr-sm-2" type="search" name="q" placeholder="Buscar..." aria-label="Buscar..." @isset ($_GET['q'])
                    value="{{ $_GET['q'] }}"
                @endisset>
                <button class="btn btn-success" type="submit">
                    <i class="fa fa-search"></i> Buscar
                </button>
            </form>
            <a class="btn btn-primary ml-2" href="{{ route('departments.create') }}/">
                <i class="fa fa-plus"></i>
                Nuevo Departamento
            </a>
        </div>
    	@if(count($departments) > 0)
        	<table class="table table-striped m-0">
        		<thead>
        			<tr>
        				<th>Nombre</th>
        				<th>Descripción</th>
                        <th class="text-center">Grupos</th>
        				<th>Supervisor</th>
        				<th class="text-center">Agentes</th>
        			</tr>
        		</thead>
        		<tbody>
        			@foreach($departments as $department)
					<tr>
						<td><a href="{{ route('departments.show', $department) }}/">{{ $department->name }}</a></td>
						<td>{{ $department->description }}</td>
                        <td class="text-center">{{ $department->groups->count() }}</td>
						<td>
							@if($department->supervisor)
								<a href="{{ route('agents.show', $department->supervisor) }}/">
									{{ $department->supervisor->user->first_name .' '. $department->supervisor->user->last_name }}
								</a>
							@else
								Sin supervisor
							@endif
						</td>
						<td class="text-center">{{ $department->agents()->count() }}</td>
					</tr>
        			@endforeach
        		</tbody>
        	</table>
            <div class="card-footer">
                {{ $departments->links() }}
            </div>
    	@else
			<div class="card-body">No se han agregado departamentos</div>
    	@endif
    </div>
</div>
@stop

laravel/resources/views/helpdesk/departments/show.blade.php
@extends('layouts.master')
@section('content')
<div class="container">
	<div class="card">
		
		<div class="card-header d-flex align-items-center">
			<a class="btn btn-link p-0" href="{{ route('departments.index') }}/">
				<i class="fa fa-angle-left fa-sm mr-1"></i>
				Regresar
			</a>
			<a class="btn btn-primary ml-auto" href="{{ route('departments.edit', $department) }}/">
				<i class="fa fa-pencil-alt fa-xs"></i>
				Editar
			</a>
		</div>

		<table class="table table-striped m-0">
			<tr>
				<th width="15%">Nombre</th>
				<td>{{ $department->name }}</td>
			</tr>

			<tr>
				<th>Descripción</th>
				<td>{{ $department->description }}</td>
			</tr>

			<tr>
				<th>Supervisor</th>
				<td>
					@if(optional($department->supervisor))
						<a href="{{ route('agents.show', $department->supervisor) }}/">
							{{ optional( optional( $department->supervisor )->user )->FullName }}
						</a>
					@else
						Sin supervisor
					@endif
				</td>
			</tr>

			<tr>
				<th>Agentes</th>
				<td>

					@if ($department->agents()->count() > 0)
						@foreach($department->agents()->where('id', '<>', $department->supervisor->id)->get() as $agent)
							<a href="{{ route('agents.show', $agent) }}/">
								{{ $agent->full_name }}
							</a> 
							@if(!$loop->last) <br> @endif
						@endforeach
					@endif

				</td>
			</tr>
		</table>

	</div>

	
	<div class="card mt-3" id="departmentsApp">
		<div class="card-header d-flex align-items-center">
			<p class="lead">Grupos</p>
			<a href="#createNewGroup" class="btn btn-primary ml-auto" data-toggle="collapse"><i class="fa fa-plus"></i> Nuevo grupo</a>
		</div>


		<div class="collapse" id="createNewGroup">
			
			<div class="row">
				<div class="col-sm-5 mx-auto">
					<form action="{{ route('departments.groups.store', $department) }}" class="mt-3 mb-3" @submit.prevent="createNewGroup">
						{{ csrf_field() }}
						<div class="form-group">
							<label>Nombre del grupo:</label>
							<input type="text"name="name" autofocus class="form-control" required>
						</div>

						<div class="form-group">
							<label>Supervisor del grupo:</label>
							<select name="supervisor_id" class="form-control" required>
								<option disabled selected value>Elige una opción</option>
								@foreach($department->agents as $agent)
								<option value="{{ $agent->id }}">{{ $agent->full_name }}</option>
								@endforeach
							</select>
						</div>

						<button class="btn btn-success"><i class="fa fa-check"></i> Crear Grupo</button>
					</form>
				</div>
			</div>

		</div>

		<table v-if="groups.length > 0" class="table table-striped m-0">
			<thead>
				<tr>
					<th>Grupo</th>
					<th>Supervisor</th>
					<th class="text-center">Agentes</th>
					<th class="text-center">Editar</th>
				</tr>
			</thead>
			<tbody>
				<tr v-for="(group, index) in groups">
					<td width="30%">@{{ group.name }}</td>
					<td width="30%">
						<span v-if="group.supervisor">
							@{{ 
								group.supervisor.user.first_name + 
								' ' + 
								group.supervisor.user.last_name 
							}}
						</span>

						<span v-else>
							Sin supervisor
						</span>
					</td>
					<td width="30%" class="text-center">
						@{{ group.agents.length }}
						Agente@{{ group.agents.length == 1 ? '' : 's' }}
					</td>
					<td class="text-center">
						<a 	href="#editDepartmentGroupModal" 
							data-toggle="modal"
							@click.prevent="edit_group(index)">
							<i class="fa fa-pencil-alt"></i>
						</a>
					</td>
				</tr>
			</tbody>
		</table>

	
		<div v-else class="card-body">
			<p class="m-0">No se han agregado grupos aun</p>
		</div>


		@component('helpdesk.components.modal', [

			'id' 	=> 'editDepartmentGroupModal',
			'title' => 'Editar información de grupo',
			'size' 	=> 'modal-lg'

		])
			
			@slot('body')

				<form :action="updateDepartmentRoute()" id="updateGroupForm" v-if="group" method="post" @submit.prevent="update_group_post">
					
					{{ method_field('PATCH') }}

					{{  csrf_field() }}

					<div class="form-group">
						<div class="form-row">
							<label class="col-sm-4 text-right col-form-label">Grupo:</label>
							<div class="col-sm-4">
								<input type="text" class="form-control" name="name" :value="group.name">
							</div>
						</div>
					</div>
	

					<div class="form-group">
						<div class="form-row">
							<label class="col-sm-4 text-right col-form-label">Supervisor:</label>
							<div class="col-sm-4">
								<select name="agents[]" 
									class="form-control"
									:value="group.supervisor ? group.supervisor.id : ''">
									
							
								<option disabled selected value>
									Elige una opción
								</option>

								@foreach($department->agents as $agent)
									
									<option value="{{ $agent->id }}">
										{{ $agent->full_name }}
									</option>

								@endforeach


								</select>
							</div>
						</div>
					</div>

			
					<div class="form-row">
						<div class="col-sm-4 mx-auto">
							<label>
								<b>Agentes en el grupo</b>
							</label>


							@foreach($department->agents as $agent)

								<div class="custom-control custom-checkbox">
								  
								  <input type="checkbox" 
								  		 class="custom-control-input"
								  		 name="agents[]"
								  		 value="{{ $agent->id }}" 
								  		 id="agentCheckBox{{ $agent->id }}"
								  		 :checked="check_if_agent_is_on_group({{$agent->id}})">


								  <label class="custom-control-label" 
								  		 for="agentCheckBox{{ $agent->id }}">
								  		
								  		{{ $agent->full_name }}

								  </label>

								</div>


							@endforeach


						</div>
					</div>

				</form>

			@endslot

			@slot('footer')

				<button type="submit" form="updateGroupForm" class="btn btn-success">
					<i class="fa fa-check"></i>
					Actualizar Grupo
				</button>

			@endslot
	

		@endcomponent
	

	</div>


</div>
@stop


@section('scripts')
	
	<script>
		var departments_app = new Vue({

			el: "#departmentsApp",

			data: {

				groups: @json($department->groups()->with(['supervisor.user', 'agents'])->latest()->get()),
				group: null

			},

			mounted: function(){


				


			},

			methods: {

				agent_route: function(agent_id){

					var route = "{{ route("agents.show", '#agent_id') }}";

					route = route.replace("#agent_id", agent_id);

					return route;

				},


				updateDepartmentRoute: function(){


					var t = this;

					var route = "{{ route('departments.groups.update', [$department, "#group_id"]) }}";

					route = route.replace("#group_id", t.group.id);

					return route;


				},


				update_group_post: function(e){


					var t = this;

					var form = $(e.target);

					var form_id = form.attr('id');

					var data = form.serialize();

					var route = form.attr('action');

					var btn = $("button[form='"+form_id+"']");

					btn.attr('disabled', 'disabled');

					$.post(route, data, function(response){


						btn.removeAttr('disabled');


					}).done(function(response){


						if(response.type == 'error'){


							alert(response.errors.join('\n'));


						}else{


							$('.modal').modal('hide');

							t.groups = response.groups;

							
						}


					});


				},


				createNewGroup: function(e){

					var t = this;
					var form = $(e.target);
					var data = form.serialize();
					var route = form.attr('action');
					var btn = $('button', form);

					$.post(route, data, function(response){

						btn.removeAttr('disabled');

					}).done(function(response){

						if(response.type == 'error'){

							alert(response.errors.join('\n'));

						}else{

							form[0].reset();

							t.groups = response;

							$('#createNewGroup').collapse('hide');

						}

					});

				},

				edit_group: function(index){


					var t = this;


					t.group = t.groups[index];


				},

				check_if_agent_is_on_group: function(agent_id){

					var t = this;

					var agents = t.group.agents;

					var response = false;

					$.each(agents, function(i, o){

						if(o.agent_id == agent_id){

							response = true;

						}

					});

					return response;

				}

			}

		});
	</script>

@stop